<p-table [value]="books$ | async"
         [tableStyle]="{ 'min-width': '50rem' }">
  <ng-template pTemplate="header">
    <tr>
      <th>Title</th>
      <th>Author</th>
      <th>Genre</th>
      <th>Isbn</th>
      <th>Published</th>
      <th>Publisher</th>
      <th>In stock</th>
      <th></th>
    </tr>
  </ng-template>
  <ng-template pTemplate="body" let-book>
    <tr>
      <td>{{ book.title }}</td>
      <td>{{ getAuthors(book.authors) }}</td>
      <td>{{ getGenres(book.genres) }}</td>
      <td>{{ book.isbn }}</td>
      <td>{{ book.published | date : 'dd/mm/yyyy' }}</td>
      <td>{{ book.publisher }}</td>
      <td>{{ book.inStock }}</td>
      <td>
        <p-button [rounded]="true" icon="pi pi-shopping-cart" class="p-button-icon" (onClick)="preview(book.id)"
        [disabled]="book.inStock == 0"></p-button>
      </td>
    </tr>
  </ng-template>
</p-table>
<p-paginator [rows]="(books$| async).length"
             [totalRecords]="total$ | async"
             (onPageChange)="onPageChange($event)"></p-paginator>

<p-dialog *ngIf="purchaseBook" header="{{purchaseBook.title}}" [(visible)]="showPurchaseModal"
          [modal]="true"
          [style]="{ width: '50vw', height: '300px' }"
          [draggable]="false"
          [resizable]="false"
          (onHide)="hidePurchaseModal()">
  <div class="grid">
    <div class="col-2"><span class="font-bold">Author</span></div>
    <div class="col-10">{{purchaseBook.authors}}</div>
    <div class="col-2"><span class="font-bold">Description</span></div>
    <div class="col-10">{{purchaseBook.description}}</div>
    <div class="col-10">
      <input type="number" pInputText #quantity [min]="1" [max]="purchaseBook.inStock">
    </div>
    <div class="col-2">
      <p-button label="Purchase" (onClick)="purchase(purchaseBook, +quantity.value)"></p-button>
    </div>
  </div>




</p-dialog>
